;;;-*- Mode:LISP; Package:CHAOS; Base:10; Syntax:Common-lisp -*-
;;; $Id: trans-form.lisp,v 1.1.1.1 1998/05/16 11:27:42 sawada Exp $
(in-package :chaos)
#|==============================================================================
				 System: CHAOS
				Module: cafeobj
			     File: trans-form.lisp
==============================================================================|#
#-:chaos-debug
(declaim (optimize (speed 3) (safety 0) #-GCL (debug 0)))
#+:chaos-debug
(declaim (optimize (speed 1) (safety 3) #-GCL (debug 3)))

;;; ****************************
;;; CafeOBJ => Chaos translation________________________________________________
;;; ****************************

(defun cafeobj-2-chaos-proc (inp)
  (let* ((args (cadr inp))
	 (from (car args))
	 (to (cadr args)))
    (if to
	(cafeobj2chaos from to)
	(cafeobj2chaos from *standard-output*))
    ))


(defun cafeobj2chaos (in-file o-file)
  (if (streamp o-file)
      (chaos-input-file :file in-file
			:proc 'cafeobj->chaos
			:args `(,in-file ,o-file))
      (with-open-file (port o-file :direction :output
			    :if-does-not-exist :create
			    :if-exists :supersede)
	(chaos-input-file :file in-file :proc 'cafeobj->chaos :args `(,in-file ,port)))
      ))

(defun cafeobj->chaos (in-file &optional (port *standard-output*))
  (let ((*print-case* :downcase)
	(*chaos-quiet* t)
	(*eval-ast* nil)
	(*dribble-ast* t)
	(*dribble-stream* port)
	(quit-flag nil))
    (princ *chaos-binary-magic* port)
    (format port "~&;;; this file is generated by CafeOBJ to Chaos converter version 1.2")
    (format port "~&;;; creation date = ~a" (get-time-string))
    (format port "~%;;; source file   = ~a" in-file)
    ;; (format port "~%;;; target file   = ~a" o-file)
    (format port "~&(in-package :chaos)~%")
    (loop (catch *top-level-tag*
	    (process-cafeobj-input)
	    (setq quit-flag t))
	  (when quit-flag (return)))
    (force-output port)))


;;; EOF
